from pathlib import Path

from extensions.chaeo.util import autonumber_new_directory, get_matching_files, loop_workflow
from extensions.chaeo.workflows import export_patches_from_multichannel_zstack

if __name__ == '__main__':
    where_czi = 'c:/Users/rhodes/projects/proj0012-trec-handoff/owncloud-sync/TREC-HD/Images/TREC_STOP_15_Kristineberg/230805_automic_AI_PA/20230805-122525_AI_PA_successfulrun_recognitiononPLL405cilindionas/Selection'
    where_output = autonumber_new_directory(
        'c:/Users/rhodes/projects/proj0011-plankton-seg/exp0016/output',
        'batch-output'
    )

    px_ilp = Path.home() / 'model-server' / 'ilastik' / 'AF405-bodies_boundaries.ilp'

    params = {
        'ilastik_project_file': px_ilp.__str__(),
        'pxmap_threshold': 0.25,
        'pixel_class': 0,
        'zmask_channel': 0,
        'patches_channel': 4,
        'mask_type': 'boxes',
        'zmask_filters': {'area': (1e3, 1e8)},
        'zmask_expand_box_by': (128, 3),
        'export_pixel_probabilities': True,
        'export_2d_patches_for_training': True,
        'export_2d_patches_for_annotation': True,
        'export_3d_patches': False,
        'export_annotated_zstack': True,
        'export_patch_masks': True,
    }

    input_files = get_matching_files(where_czi, 'czi')

    loop_workflow(
        input_files,
        where_output,
        export_patches_from_multichannel_zstack,
        params,
        catch_and_continue=False,
    )

    print('Finished')